/**
 *  \file   mmcsd_evm.cfg
 *
 *  \brief  Sysbios config file for mmcsd C66X test project on DRA7xx EVMs.
 *
 */

/*
 * Copyright (C) 2017 Texas Instruments Incorporated - http://www.ti.com/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * Neither the name of Texas Instruments Incorporated nor the names of
 * its contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/* ================ General configuration ================ */
var Memory    = xdc.useModule('xdc.runtime.Memory');
var HeapMem   = xdc.useModule('ti.sysbios.heaps.HeapMem');
var HeapBuf   = xdc.useModule('ti.sysbios.heaps.HeapBuf');
var Log       = xdc.useModule('xdc.runtime.Log');
var Task      = xdc.useModule('ti.sysbios.knl.Task');
var Semaphore = xdc.useModule('ti.sysbios.knl.Semaphore');
var ECM       = xdc.useModule('ti.sysbios.family.c64p.EventCombiner');
var Hwi       = xdc.useModule('ti.sysbios.hal.Hwi');
var System    = xdc.useModule('xdc.runtime.System');
var SysStd    = xdc.useModule('xdc.runtime.SysStd');
var IntXbar   = xdc.useModule('ti.sysbios.family.shared.vayu.IntXbar');
System.SupportProxy     = SysStd;
System.extendedFormats += "%f";

var SourceDir = xdc.useModule('xdc.cfg.SourceDir');
SourceDir.outputDir = "src";

/* Create a default system heap using ti.bios.HeapMem. */
var heapMemParams1 = new HeapMem.Params;
heapMemParams1.size        = 8192 * 25;
heapMemParams1.sectionName = "systemHeap";
Program.global.heap0       = HeapMem.create(heapMemParams1);

/* This is the default memory heap. */
Memory.defaultHeapInstance    = Program.global.heap0;
Program.sectMap["systemHeap"] = Program.platform.stackMemory;

/*
 * Enable Event Groups here and registering of ISR for specific GEM INTC is done
 * using EventCombiner_dispatchPlug() and Hwi_eventMap() APIs
 */
var exception = xdc.useModule('ti.sysbios.family.c64p.Exception');
exception.enablePrint = true;

/* ================ BIOS configuration ================ */

var BIOS = xdc.useModule('ti.sysbios.BIOS');

/* Enable BIOS Task Scheduler */
BIOS.taskEnabled = true;

/* ================ Task configuration ================ */

/* No runtime stack checking is performed */
Task.checkStackFlag = false;

/* Reduce the number of task priorities */
Task.numPriorities = 4;

/* Define and add one Task Hook Set */
Task.addHookSet({
    registerFxn: '&TaskRegisterId',
    switchFxn: '&mySwitch',
});

/* ================ Driver configuration ================ */
var soc   = Program.build.cfgArgs.SOC.toLowerCase();
var board = Program.build.cfgArgs.BOARD;
xdc.print("# !!!  Current soc is [" + soc + "] !!!");
xdc.print("# !!!  Current board is [" + board + "] !!!");

/* Load the OSAL package */
var osType = "tirtos";
var Osal   = xdc.useModule('ti.osal.Settings');
Osal.osType  = osType;
Osal.socType = soc;

/* Load Profiling package */
var Utils = xdc.loadPackage('ti.utils.profiling');

/* Load the MMCSD package */
var Mmcsd = xdc.loadPackage('ti.drv.mmcsd');
Mmcsd.Settings.enableProfiling = true;
Mmcsd.Settings.socType         = soc;

var Fatfs = xdc.loadPackage('ti.fs.fatfs');

/* Load the GPIO package */
var GPIO = xdc.loadPackage('ti.drv.gpio');
GPIO.Settings.socType = soc;

/* Load the UART package */
var UART = xdc.loadPackage('ti.drv.uart');
UART.Settings.socType = soc;

/* Load the I2C package */
var I2C = xdc.loadPackage('ti.drv.i2c');
I2C.Settings.socType = soc;

/* Load the PM package */
var pm = xdc.loadPackage('ti.drv.pm');
pm.Settings.socType = soc;

/* Load the CSL package */
var CSL = xdc.loadPackage('ti.csl');
CSL.Settings.deviceType = soc;

/* Load the Board package and set the board name */
var Board = xdc.loadPackage('ti.board');
Board.Settings.boardName = board;

/* ================ Memory sections configuration ================ */
Program.sectMap[".text"]   = "EXT_RAM";
Program.sectMap[".const"]  = "EXT_RAM";
Program.sectMap[".plt"]    = "EXT_RAM";
Program.sectMap[".bss:.tx_buf"] = "EXT_RAM";
Program.sectMap[".bss:.rx_buf"] = "EXT_RAM";

if (soc == "dra72x" || soc == "dra75x")
{
    /* Place IODELAY code in OCMC_RAM1 as DDR exeuction of this code will lead to
     * failures.
     */
    Program.sectMap["BOARD_IO_DELAY_DATA"] = "OCMC_RAM1";
    Program.sectMap["BOARD_IO_DELAY_CODE"] = "OCMC_RAM1";
}

/* Align DSP entry point address according to the SBL requirements */
Program.sectMap[".text:_c_int00"] = new Program.SectionSpec();
Program.sectMap[".text:_c_int00"].loadSegment = "EXT_RAM";
Program.sectMap[".text:_c_int00"].loadAlign = 0x400;
